/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#pragma once

#include "IResourceManager.hpp"
#include "Base/ITickable.hpp"
#include "Base/ICloseable.hpp"
#include "Scene/Scene.hpp"
#include "Scene/UI/UI.hpp"
#include <string>

namespace OpenVulkano
{
	class IWindow;
	class IGraphicsAppManager;

	class IRenderer : public ITickable, public ICloseable
	{
	public:
		virtual ~IRenderer() = default;

		virtual void Init(IGraphicsAppManager* graphicsAppManager, IWindow* window) = 0;

		virtual std::string GetMainRenderDeviceName() = 0;
		virtual void Resize(uint32_t newWidth, uint32_t newHeight) = 0;

		virtual void SetScene(Scene::Scene* scene) = 0;
		virtual Scene::Scene* GetScene() = 0;

		virtual void SetActiveUi(Scene::UI::Ui* ui) = 0;
		virtual Scene::UI::Ui* GetActiveUi() = 0;

		virtual IResourceManager* GetIResourceManager() = 0;

		virtual float GetLastQueriedDepthValue() = 0;
		virtual void SetQueryDepthValue(const Math::Vector2f& depthCoordinates) = 0;
	};
}
